<template>
  <div id="parentx-demo-2">
    <vs-sidebar
      position-right
      parent="body"
      :hidden-background="false"
      v-model="active"
      id="habit-form-sidebar"
      class="form-data-sidebar items-no-padding"
      click-not-close
    >
      <!-- HEADER -->
      <div class="mt-6 flex items-center justify-between px-6">
        <h4>
          THÊM THÓI QUEN
        </h4>
        <feather-icon
          icon="XIcon"
          class="cursor-pointer"
          @click="$emit('close', false)"
        ></feather-icon>
      </div>
      <!-- /HEADER -->

      <vs-divider class="mb-0"></vs-divider>

      <VuePerfectScrollbar
        class="scroll-area"
        :settings="settings"
        :key="$vs.rtl"
        ref="formPS"
      >
        <div class="p-6 mb-10">
          <form-wizard
            :Lazy="true"
            ref="formFW"
            color="rgba(var(--vs-primary), 1)"
            :title="null"
            :subtitle="null"
            nextButtonText="Tiếp theo"
            backButtonText="Trở lại"
            finishButtonText="Lưu"
            @on-complete="onSave"
            @on-change="onChangeStep"
          >
            <tab-content title="Thư viện" class="mb-5">
              <template>
                <HabitGallery v-model="habitLocal" @goToNextTab="nextTab" />
              </template>
            </tab-content>

            <tab-content title="Thông tin chung" class="mb-5">
              <template>
                <HabitGeneralForm v-model="habitLocal" />
              </template>
            </tab-content>

            <tab-content title="Mục tiêu" class="mb-5">
              <template>
                <HabitGoalForm
                  v-model="habitLocal"
                  @change="updateData($event.field, $event.text)"
                />
              </template>
            </tab-content>
          </form-wizard>
        </div>
      </VuePerfectScrollbar>
    </vs-sidebar>
  </div>
</template>

<script>
import _clone from "lodash/clone";
import VuePerfectScrollbar from "vue-perfect-scrollbar";
import { FormWizard, TabContent } from "vue-form-wizard";
import "vue-form-wizard/dist/vue-form-wizard.min.css";
import "flatpickr/dist/flatpickr.css";
// import "flatpickr/dist/themes/material_blue.css";
// import FormSidebar from "../../components/sidebar/FormSidebar";
import HabitGallery from "./components/form/HabitGallery";
import HabitGeneralForm from "./components/form/HabitGeneralForm";
import HabitGoalForm from "./components/form/HabitGoalForm";

export default {
  components: {
    VuePerfectScrollbar,
    FormWizard,
    TabContent,
    HabitGallery,
    HabitGeneralForm,
    HabitGoalForm
  },
  props: {
    active: { type: Boolean, required: true }
  },
  data() {
    return {
      habitLocal: {
        name: "",
        iconColor: "",
        iconText: "",
        iconImage: null,
        imgBgColor: "",
        imgUnCheckIn: null,
        imgCheckIn: null,
        isSaveDiary: false,
        remind: [],
        motivationContent: "",
        motivationImages: [],
        missionDayUnit: 0,
        missionDayCheckInStep: 1,
        missionDayTarget: 1,
        typeFrequency: "daily",
        dailyDays: [0, 1, 2, 3, 4, 5, 6], // [...Array(7).keys()] ~ HabitDailyDaysEnums
        weeklyDays: null
      },
      // Scroll Bar Setting
      settings: {
        maxScrollbarLength: 60,
        wheelSpeed: 0.6
      }
    };
  },
  methods: {
    nextTab() {
      this.$refs.formFW.nextTab();
    },
    onChangeStep(prev, next) {
      this.$refs.formPS.$el.scrollTop = 0; // Scroll step screen to top
    },
    updateData(field, text) {
      // console.log("[HABIT_FORM]", field, text);
      const newData = { ...this.habitLocal, [field]: text };
      this.habitLocal = newData;
    },
    onSave() {
      // console.log(this.habitLocal);
      const postData = this.buildPostData();
      const payload = {
        habit: postData,
        notify: this.$vs.notify,
        callback: () => {
          this.$emit("close");
        }
      };

      this.$validator.validateAll().then(result => {
        if (result) {
          this.$store
            .dispatch("habit/addHabit", Object.assign({}, payload))
            .catch(error => {
              this.$error({ message: error.message });
            });
        }
      });
    },
    buildPostData() {
      return {
        name: this.habitLocal.name,
        icon: {
          iconColor: this.habitLocal.iconColor,
          iconText: this.habitLocal.iconText,
          iconImage: this.habitLocal.iconImage.toString()
        },
        images: {
          imgBg: this.habitLocal.imgBgColor,
          imgUnCheckIn: this.habitLocal.imgUnCheckIn.toString(),
          imgCheckIn: this.habitLocal.imgCheckIn.toString()
        },
        isSaveDiary: this.habitLocal.isSaveDiary,
        remind: this.habitLocal.remind.map(reminder => {
          const items = reminder.split(":");
          return { hour: parseInt(items[0]), minute: parseInt(items[1]) };
        }),
        motivation: {
          content: this.habitLocal.motivationContent,
          images: this.habitLocal.motivationImages
        },
        habitFinishDate: "",
        missionDayUnit: this.habitLocal.missionDayUnit.toString(),
        missionDayCheckInStep: parseInt(this.habitLocal.missionDayCheckInStep),
        missionDayTarget: parseInt(this.habitLocal.missionDayTarget),
        isFinished: false,
        frequency: {
          typeFrequency: this.habitLocal.typeFrequency,
          dailyDays:
            this.habitLocal.typeFrequency == "daily"
              ? this.habitLocal.dailyDays
              : [],
          weeklyDays:
            this.habitLocal.typeFrequency == "weekly"
              ? this.habitLocal.weeklyDays
              : 0,
          weeklyUnit: null
        },
        habitProgress: []
      };
    },
    clearFields() {
      this.$nextTick(() => {
        this.habitLocal = {
          name: "",
          iconColor: "",
          iconText: "",
          iconImage: null,
          imgBgColor: "",
          imgUnCheckIn: null,
          imgCheckIn: null,
          isSaveDiary: false,
          remind: [],
          motivationContent: "",
          motivationImages: [],
          missionDayUnit: 0,
          missionDayCheckInStep: 1,
          missionDayTarget: 1,
          typeFrequency: "daily",
          dailyDays: [0, 1, 2, 3, 4, 5, 6],
          weeklyDays: null
        };
      });
    }
  },
  watch: {
    active(val) {
      this.clearFields();
      this.$refs.formFW.reset();
    }
  }
};
</script>

<style lang="scss" scoped>
@import "@/assets/scss/vuexy/_variables.scss";
// Side bar
.form-data-sidebar {
  ::v-deep .vs-sidebar--background {
    z-index: 52010;
  }

  ::v-deep .vs-sidebar {
    z-index: 52010;
    width: 600px;
    max-width: 90vw;
  }
}
</style>
